// Visual Micro is in vMicro>General>Tutorial Mode
// 
/*
    Name:       RF2FFBHB.ino
    Created:	2019-03-02 10:38:51
    Author:     SOVRUM\danove_b
*/

// Define User Types below here or use a .h file
//


// Define Function Prototypes that use User Types below here or use a .h file
//

// table of 256 sine values / one sine period / stored in flash memory

PROGMEM const unsigned char sine256[] = {
	127,130,133,136,139,143,146,149,152,155,158,161,164,167,170,173,176,178,181,184,187,190,192,195,198,200,203,205,208,210,212,215,217,219,221,223,225,227,229,231,233,234,236,238,239,240,
	242,243,244,245,247,248,249,249,250,251,252,252,253,253,253,254,254,254,254,254,254,254,253,253,253,252,252,251,250,249,249,248,247,245,244,243,242,240,239,238,236,234,233,231,229,227,225,223,
	221,219,217,215,212,210,208,205,203,200,198,195,192,190,187,184,181,178,176,173,170,167,164,161,158,155,152,149,146,143,139,136,133,130,127,124,121,118,115,111,108,105,102,99,96,93,90,87,84,81,78,
	76,73,70,67,64,62,59,56,54,51,49,46,44,42,39,37,35,33,31,29,27,25,23,21,20,18,16,15,14,12,11,10,9,7,6,5,5,4,3,2,2,1,1,1,0,0,0,0,0,0,0,1,1,1,2,2,3,4,5,5,6,7,9,10,11,12,14,15,16,18,20,21,23,25,27,29,31,
	33,35,37,39,42,44,46,49,51,54,56,59,62,64,67,70,73,76,78,81,84,87,90,93,96,99,102,105,108,111,115,118,121,124

};



byte	angle;
byte	ph0, ph1, ph2;
byte	offset;

float	Nm;
uint8_t Enable;
int		Yellow, Blue, Green;


int delayms;

void setup()
{

	Serial.begin(115200);
	digitalWrite(8, 0);
	pinMode(8, OUTPUT);
	pinMode(9, OUTPUT);     // pin9= PWM  output / frequency output
	pinMode(10, OUTPUT);     // pin10= PWM  output / frequency output
	pinMode(11, OUTPUT);     // pin11= PWM  output / frequency output

	pinMode(2, INPUT_PULLUP);
	pinMode(3, INPUT_PULLUP);
	pinMode(4, INPUT_PULLUP);
	pinMode(5, INPUT_PULLUP);

	Setup_timer1();
	Enable =0;

	delayms = 1000;
}

void loop() {
	


	MotorControl();

	/*
	ph0 = angle;
	digitalWrite(8, Enable);

	OCR1C = ph0;  // pwm pin 11
	DDRB |= 1 << 7;    // Set Output Mode B7
	TCCR1A |= 0x08;  // Set PWM value

	OCR1B = ph0;  // pwm pin 10
	DDRB |= 1 << 6;    // Set Output Mode B6
	TCCR1A |= 0x20;  // Set PWM value

	OCR1A = ph0;  // pwm pin 9
	DDRB |= 1 << 5;    // Set Output Mode B5
	TCCR1A |= 0x80;  // Activate channel
	*/
}


void MotorControl() {

	

	int AD0 = analogRead(A0);

	Nm = map(AD0, 0, 1023, -1000, 1000);
	Nm = Nm / 1000;
	
	if (Nm > 0) {
		angle = (Commutate() * 42) + 80;
	}
	else {
		angle = (Commutate() * 42) + 220;
	}
	
	Enable = !digitalRead(5) && (abs(Nm) > 0.05);

	//Commutation angle and torque level 0-1 as parameters	
	SetTorque(angle, abs(Nm));
	digitalWrite(8, Enable);

}

void Setup_timer1() {
	// TCCR1A configuration
	//  00 : Channel A disabled D9
	//  00 : Channel B disabled D10
	//  00 : Channel C disabled D11
	//  01 : Fast PWM 8 bit
	
	//Default
	TCCR1A = 1;
	
	
	//TCCR1A = 2;
	
	
	// TCCR1B configuration
	// Clock mode and Fast PWM 8 bit

	/*	
	#define PWM62k   1   //62500 Hz
	#define PWM8k    2   // 7812 Hz
	#define PWM1k    3   //  976 Hz
	#define PWM244   4   //  244 Hz
	#define PWM61    5   //   61 Hz
	*/
	TCCR1B = 2 | 0x08;
	
	//Default
	//TCCR1B = 1 | 0x08;

	// TCCR1C configuration
	TCCR1C = 0;


	//Tagit frn nuvarande:
	//TCCR1A = 0b10100000;
	//TCCR1B = 0b00010001;
	//ICR1 = 256;
}

byte Commutate() {
	Yellow = digitalRead(2);
	Blue = digitalRead(3);
	Green = digitalRead(4);


	if (Yellow && !Green && !Blue) {
		return 0;
	}
	if (Yellow && Green && !Blue) {
		return 1;
	}
	if (!Yellow && Green && !Blue) {
		return 2;
	}
	if (!Yellow && Green && Blue) {
		return 3;
	}
	if (!Yellow && !Green && Blue) {
		return 4;
	}
	if (Yellow && !Green && Blue) {
		return 5;
	}
}

byte CalcTorque(byte angle, float torque) {
	byte	sineVal;

	sineVal = pgm_read_byte_near(sine256 + angle);

	if (sineVal > 127) {
		sineVal = ((sineVal - 127) * torque) + 127;
		return sineVal;
	}
	sineVal = 127 - ((127 - sineVal) * torque);
	return sineVal;
}

void SetTorque(byte SteeringAngle, float Torque) {

	ph0 = CalcTorque(SteeringAngle + 0, Torque);
	ph1 = CalcTorque(SteeringAngle + 85, Torque);
	ph2 = CalcTorque(SteeringAngle + 170, Torque);


	OCR1C = ph0;  // pwm pin 11
	DDRB |= 1 << 7;    // Set Output Mode B7
	TCCR1A |= 0x08;  // Set PWM value

	OCR1B = ph1;  // pwm pin 10
	DDRB |= 1 << 6;    // Set Output Mode B6
	TCCR1A |= 0x20;  // Set PWM value

	OCR1A = ph2;  // pwm pin 9
	DDRB |= 1 << 5;    // Set Output Mode B5
	TCCR1A |= 0x80;  // Activate channel
}